diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wimax/model/bs-uplink-scheduler-mbqos.cc ns-3.32/src/wimax/model/bs-uplink-scheduler-mbqos.cc
--- ns-3.31/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2020-10-06 15:35:43.000000000 -0700
@@ -162,7 +162,7 @@
 UplinkSchedulerMBQoS::UplinkSchedWindowTimer (void)
 {
 
-  NS_LOG (LOG_DEBUG, "Window Reset at " << (Simulator::Now ()).GetSeconds ());
+  NS_LOG (LOG_DEBUG, "Window Reset at " << (Simulator::Now ()).As (Time::S));
 
   uint32_t min_bw = 0;
 
@@ -304,7 +304,7 @@
                    (grant has been referred by different names e.g. transmission opportunity, slot,         uplink allocation, etc)*/
                   if (ssRecord->GetHasServiceFlowUgs ())
                     {
-                      NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds () << " offering be unicast polling");
+                      NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S) << " offering be unicast polling");
                       // Recover period interval information for UGS flow
                       Time frame_duration = GetBs ()->GetPhy ()->GetFrameDuration ();
                       Time
@@ -330,14 +330,14 @@
                   // enqueue allocate unicast polls for rtPS flows if bandwidth is available
                   if (ssRecord->GetHasServiceFlowRtps ())
                     {
-                      NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds () << " offering rtps unicast polling");
+                      NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S) << " offering rtps unicast polling");
                       Ptr<UlJob> jobRTPSPoll = CreateUlJob (ssRecord, ServiceFlow::SF_TYPE_RTPS, UNICAST_POLLING);
                       EnqueueJob (UlJob::HIGH, jobRTPSPoll);
                     }
 
                   if (ssRecord->GetHasServiceFlowNrtps ())
                     {
-                      NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds () << " offering nrtps unicast polling");
+                      NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S) << " offering nrtps unicast polling");
                       // allocate unicast polls for nrtPS flows if bandwidth is available
                       Ptr<UlJob> jobNRTPSPoll = CreateUlJob (ssRecord, ServiceFlow::SF_TYPE_NRTPS, UNICAST_POLLING);
                       EnqueueJob (UlJob::HIGH, jobNRTPSPoll);
@@ -345,7 +345,7 @@
 
                   if (ssRecord->GetHasServiceFlowBe ())
                     {
-                      NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds () << " offering be unicast polling");
+                      NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S) << " offering be unicast polling");
                       // finally allocate unicast polls for BE flows if bandwidth is available
                       Ptr<UlJob> jobBEPoll = CreateUlJob (ssRecord, ServiceFlow::SF_TYPE_BE, UNICAST_POLLING);
                       EnqueueJob (UlJob::HIGH, jobBEPoll);
@@ -354,7 +354,7 @@
             }
         }
     }
-  NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds ()<< " high queue has " << m_uplinkJobs_high.size ()<< " jobs - after sched");
+  NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S)<< " high queue has " << m_uplinkJobs_high.size ()<< " jobs - after sched");
 
   uint32_t availableSymbolsAux = availableSymbols;
   uint32_t symbolsUsed = 0;
@@ -369,7 +369,7 @@
   CheckMinimumBandwidth (availableSymbolsAux);
 
   // Scheduling high priority queue
-  NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds ()<< " high queue has " << m_uplinkJobs_high.size ()<< " jobs");
+  NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S)<< " high queue has " << m_uplinkJobs_high.size ()<< " jobs");
   while ((availableSymbols) && (!m_uplinkJobs_high.empty ()))
     {
 
@@ -411,11 +411,11 @@
       m_uplinkJobs_high.pop_front ();
     }
 
-  NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds ()<< " interqueue has " << m_uplinkJobs_inter.size ()<< " jobs");
+  NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S)<< " interqueue has " << m_uplinkJobs_inter.size ()<< " jobs");
   /* Scheduling intermediate priority queue */
   while ((availableSymbols) && (!m_uplinkJobs_inter.empty ()))
     {
-      NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds ()<< " Scheduling interqueue");
+      NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S)<< " Scheduling interqueue");
       Ptr<UlJob> job = m_uplinkJobs_inter.front ();
       OfdmUlMapIe ulMapIe;
       SSRecord * ssRecord = job->GetSsRecord ();
@@ -515,7 +515,7 @@
       if (availableSymbols >= allocSizeSymbols)
         {
           NS_LOG_DEBUG (
-            "At " << Simulator::Now ().GetSeconds ()<<" BS uplink scheduler, "
+            "At " << Simulator::Now ().As (Time::S)<<" BS uplink scheduler, "
                   << serviceFlow->GetSchedulingTypeStr ()
                   << " allocation, size: " << allocSizeSymbols << " symbols"
                   << ", CID: "
@@ -665,9 +665,9 @@
 
               int64_t frame = ((deadline - Simulator::Now ()) / frame_duration).GetHigh ();
 
-              NS_LOG_DEBUG ("At " << Simulator::Now ().GetSeconds () << " reserved traffic rate: "
+              NS_LOG_DEBUG ("At " << Simulator::Now ().As (Time::S) << " reserved traffic rate: "
                                   << job->GetServiceFlow ()->GetMinReservedTrafficRate ()
-                                  <<" deadline: "<<job->GetDeadline ().GetSeconds () << " frame start: "<<GetBs ()->m_frameStartTime.GetSeconds ()
+                                  <<" deadline: "<<job->GetDeadline ().As (Time::S) << " frame start: "<<GetBs ()->m_frameStartTime.As (Time::S)
                                   <<" frame duration: "<< frame_duration );
 
               // should be schedule in this frame to max latency
@@ -1108,8 +1108,8 @@
   Time currentTime = Simulator::Now ();
   Time period = deadline; // So that deadline is properly updated..
 
-  NS_LOG_DEBUG ("At "<<Simulator::Now ().GetSeconds ()<<" at BS uplink scheduler, processing bandwidth request from." <<
-                ssRecord->GetMacAddress () << " and sf " << serviceFlow->GetSchedulingType () <<" with deadline in " << deadline.GetSeconds () << " and size " << size << " aggreg size " << bwRequestHdr.GetBr ());
+  NS_LOG_DEBUG ("At "<<Simulator::Now ().As (Time::S)<<" at BS uplink scheduler, processing bandwidth request from." <<
+                ssRecord->GetMacAddress () << " and sf " << serviceFlow->GetSchedulingType () <<" with deadline in " << deadline.As (Time::S) << " and size " << size << " aggreg size " << bwRequestHdr.GetBr ());
 
   // Record data in job
   job->SetSsRecord (ssRecord);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wscript ns-3.32/src/wscript
--- ns-3.31/src/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -278,10 +278,9 @@
             pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
     defines = list(pymod.env['DEFINES'])
     defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_32=', 'NS3_DEPRECATED_H'])
     defines.extend(['NS_DEPRECATED_3_31=', 'NS3_DEPRECATED_H'])
     defines.extend(['NS_DEPRECATED_3_30=', 'NS3_DEPRECATED_H'])
-    defines.extend(['NS_DEPRECATED_3_27=', 'NS3_DEPRECATED_H'])
-    defines.extend(['NS_DEPRECATED_3_26=', 'NS3_DEPRECATED_H'])
     if Utils.unversioned_sys_platform()== 'win32':
         try:
             defines.remove('_DEBUG') # causes undefined symbols on win32
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/test.py ns-3.32/test.py
--- ns-3.31/test.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/test.py	2020-10-06 15:35:43.000000000 -0700
@@ -269,12 +269,12 @@
 # A simple example of writing a text file with a test result summary.  It is
 # expected that this output will be fine for developers looking for problems.
 #
-def node_to_text(test, f):
+def node_to_text(test, f, test_type='Suite'):
     (result, name, reason, time_real) = read_test(test)
     if reason:
         reason = " (%s)" % reason
 
-    output = "%s: Test Suite \"%s\" (%s)%s\n" % (result, name, time_real, reason)
+    output = "%s: Test %s \"%s\" (%s)%s\n" % (result, test_type, name, time_real, reason)
     f.write(output)
     for details in test.findall('FailureDetails'):
         f.write("    Details:\n")
@@ -285,7 +285,7 @@
         f.write("      File:      %s\n" % details.find('File').text)
         f.write("      Line:      %s\n" % details.find('Line').text)
     for child in test.findall('Test'):
-        node_to_text(child, f)
+        node_to_text(child, f, 'Case')
 
 def translate_to_text(results_file, text_file):
     text_file += '.txt'
@@ -2026,10 +2026,10 @@
 
     # From waf/waflib/Options.py
     envcolor=os.environ.get('NOCOLOR','') and 'no' or 'auto' or 'yes'
-    
+
     if options.nocolor or envcolor == 'no':
         colors_lst['USE'] = False
-    
+
     return run_tests()
 
 if __name__ == '__main__':
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/utils/check-style.py ns-3.32/utils/check-style.py
--- ns-3.31/utils/check-style.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/utils/check-style.py	2020-10-06 15:35:43.000000000 -0700
@@ -106,6 +106,7 @@
 sp_func_call_paren=Add
 sp_after_semi_for=Ignore
 sp_before_sparen=Ignore
+sp_before_ellipsis=Remove
 sp_type_func=Ignore
 sp_after_type=Ignore
 nl_class_leave_one_liners=True
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/utils/print-introspected-doxygen.cc ns-3.32/utils/print-introspected-doxygen.cc
--- ns-3.31/utils/print-introspected-doxygen.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/utils/print-introspected-doxygen.cc	2020-10-06 15:35:43.000000000 -0700
@@ -1570,7 +1570,14 @@
   PrintAttributeValueSection  (os, "ObjectMap", false);
   PrintMakeAccessors          (os, "ObjectMap");
   PrintMakeChecker            (os, "ObjectMap", "object-map.h");
+
+  PrintAttributeValueSection  (os, "Pair", false);
+  PrintAttributeValueWithName (os, "Pair", "std::pair<A, B>", "pair.h");
+  PrintMakeChecker            (os, "Pair",  "pair.h");
   
+  PrintAttributeValueSection  (os, "AttributeContainer", false);
+  PrintAttributeValueWithName (os, "AttributeContainer", "AttributeContainer", "attribute-container.h");
+  PrintMakeChecker            (os, "AttributeContainer",  "attribute-container.h");
 }  // PrintAttributeImplementations ()
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/VERSION ns-3.32/VERSION
--- ns-3.31/VERSION	2020-06-27 17:39:17.000000000 -0700
+++ ns-3.32/VERSION	2020-10-06 19:45:35.000000000 -0700
@@ -1 +1 @@
-3.31
+3.32
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/waf-tools/versioning.py ns-3.32/waf-tools/versioning.py
--- ns-3.31/waf-tools/versioning.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/waf-tools/versioning.py	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,262 @@
+## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
+
+import re
+
+from waflib import ConfigSet, Configure, Context, Options, Task, TaskGen
+
+CACHE_FILE = 'version.cache'
+
+class ns3_version_info(Task.Task):
+    '''Base task which implements functionality common to all inherited tasks
+
+       This class handles parsing the ns-3 version tag into component parts
+       as well as saving the version fields to a cache file
+
+       All version fields should be stored in the fields property
+
+       Derived classes should override _find_closest_tag() and 
+       _find_closest_ns3_tag()
+    '''
+
+    def __init__(self, *args, **kwargs):
+        self._fields = ConfigSet.ConfigSet()
+
+        super(ns3_version_info, self).__init__(*args, **kwargs)
+
+    @property
+    def fields(self):
+        return self._fields
+
+    def _find_closest_tag(self, ctx):
+        """Override in derived classes"""
+        pass
+
+    def _find_closest_ns3_tag(self, ctx):
+        """Override in derived classes"""
+        pass
+
+    def _parse_version_tag(self, ctx, tag):
+        safe_tag = tag.strip()
+        matches = re.match("ns-(\d+)\.(\d+)(?:.(\d+))?(?:-(RC.+))?.*", safe_tag)
+          
+        if not matches:
+            return False
+
+        self.fields['VERSION_TAG'] = '"{}"'.format(safe_tag)
+        self.fields['VERSION_MAJOR'] = matches.group(1)
+        self.fields['VERSION_MINOR'] = matches.group(2)
+
+        patch = matches.group(3)
+
+        if not patch:
+            patch = '0'
+
+        self.fields['VERSION_PATCH'] = patch 
+
+        release_candidate = matches.group(4)
+
+        if not release_candidate:
+            release_candidate = ''
+
+        self.fields['VERSION_RELEASE_CANDIDATE'] = '"{}"'.format(release_candidate)
+
+        return True
+
+    def run(self):
+        ctx = self.generator.bld
+
+        try:
+            self._find_closest_tag(ctx)
+
+            if 'VERSION_TAG' not in self.fields:
+                self._find_closest_ns3_tag(ctx)
+
+            #Generate the path where the cache file will be stored
+            base_path = self.generator.path.make_node('model')
+            cache_path = base_path.make_node(CACHE_FILE)
+
+            #Write the version information out to the cache file 
+            #The cache file is used to populate the version fields when a git 
+            #repository can not be found 
+            self.fields.store(cache_path.abspath())
+
+            #merge version info into main configset
+            ctx.env.update(self.fields)
+
+        except Exception as e:
+            ctx.to_log("Extracting version information from tags failed: {}\n".format(e)) 
+            return 1
+    
+        return 0
+
+class git_ns3_version_info(ns3_version_info):
+    '''Task to generate version fields from an ns-3 git repository'''
+    always_run = True 
+
+    def _find_closest_tag(self, ctx):
+        cmd = [
+            'git',
+            'describe',
+            '--tags',
+            '--dirty',
+            '--long'
+        ]
+    
+        try:
+            out = ctx.cmd_and_log(cmd, 
+                                  output=Context.STDOUT,
+                                  quiet=Context.BOTH)
+        except Exception as e:
+            raise Exception(e.stderr.strip())
+   
+        matches = re.match('(.+)-(\d+)-(g[a-fA-F0-9]+)(?:-(dirty))?', out)
+
+        if not matches:
+            raise ValueError("Closest tag found in git log"
+                             "does not match the expected format (tag='{}')"
+                             .format(out))
+
+        tag = matches.group(1)
+
+        self.fields['CLOSEST_TAG'] = '"{}"'.format(tag)
+        self.fields['VERSION_TAG_DISTANCE'] = matches.group(2)
+        self.fields['VERSION_COMMIT_HASH'] = '"{}"'.format(matches.group(3))
+        self.fields['VERSION_DIRTY_FLAG'] = '1' if matches.group(4) else '0'
+        
+        self._parse_version_tag(ctx, tag) 
+
+    def _find_closest_ns3_tag(self, ctx):
+        cmd = [
+            'git',
+            'describe',
+            '--tags',
+            '--abbrev=0',
+            '--match',
+            'ns-3*',
+            'HEAD'
+        ]
+    
+        try:
+            out = ctx.cmd_and_log(cmd, 
+                                  output=Context.STDOUT,
+                                  quiet=Context.BOTH)
+        except Exception as e:
+            raise Exception(e.stderr.strip())
+
+        tag = out.strip() 
+
+        result = self._parse_version_tag(ctx, tag)
+
+        if not result:
+            raise ValueError("Closest ns3 tag found in git log"
+                             " does not match the expected format (tag='{}')"
+                             .format(tag))
+
+@TaskGen.feature('version-defines')
+def generate_version_defines(self):
+
+    #Create a substitution task to generate version-defines.h
+    #from fields stored in env 
+    subst_task = self.create_task('subst', self.source, self.target)
+
+    if self.env['HAVE_NS3_REPO']:
+        #if a git repo is present, run the version task first to
+        #populate the appropriate fields with data from the git repo
+        version_task = self.create_task('git_ns3_version_info')
+        subst_task.set_run_after(version_task)
+
+@Configure.conf
+def check_git_repo(self):
+    '''Determine if a git repository is present'''
+
+    root = False
+    cmd = [
+            'git',
+            'rev-parse',
+            '--show-toplevel'
+    ]
+
+    try:
+        #determine if the current directory is part of a git repository 
+        self.find_program('git')
+    
+        out = self.cmd_and_log(cmd, output=Context.STDOUT, quiet=Context.BOTH)
+    
+        root = out.strip() 
+    except Exception:
+        root = False
+    
+    self.msg('Checking for local git repository', root)
+    
+    return bool(root) 
+
+@Configure.conf
+def check_git_repo_has_ns3_tags(self):
+    '''Determine if the git repository is an ns-3 repository
+
+       A repository is considered an ns-3 repository if it has at least one 
+       tag that matches the regex ns-3*
+    '''
+
+    tag = False
+
+    cmd = [
+        'git',
+        'describe',
+        '--tags',
+        '--abbrev=0',
+        '--match',
+        'ns-3.[0-9]*'
+    ]
+
+    try:
+        out = self.cmd_and_log(cmd, output=Context.STDOUT, quiet=Context.BOTH)
+
+        tag = out.strip()
+
+    except Exception:
+        tag = False
+
+    self.msg('Checking local git repository for ns3 tags', tag)
+
+    return bool(tag) 
+
+def configure(ctx):
+
+    has_git_repo = False
+    has_ns3_tags = False
+
+    if not Options.options.enable_build_version:
+        return
+
+    if ctx.check_git_repo():
+        has_git_repo = True
+        has_ns3_tags = ctx.check_git_repo_has_ns3_tags()
+
+    ctx.env['HAVE_GIT_REPO'] = has_git_repo
+    ctx.env['HAVE_NS3_REPO'] = has_ns3_tags
+
+    if not has_ns3_tags:
+        version_cache = ConfigSet.ConfigSet ()
+
+        #no ns-3 repository, look for a cache file containing the version info
+        ctx.start_msg('Searching for file {}'.format(CACHE_FILE))
+
+        glob_pattern = '**/{}'.format(CACHE_FILE)
+        cache_path = ctx.path.ant_glob(glob_pattern)
+
+        if len(cache_path) > 0:
+            #Found cache file
+            #Load it and merge the information into the main context environment
+            src_path = cache_path[0].srcpath()
+            ctx.end_msg(src_path)
+
+            version_cache.load (src_path)
+        else:
+            ctx.end_msg(False)
+
+            ctx.fatal('Unable to find ns3 git repository or version.cache file '
+                        'containing version information')
+
+        ctx.env.update(version_cache)
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/wscript ns-3.32/wscript
--- ns-3.31/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -259,6 +259,14 @@
     opt.add_option('--cxx-standard',
                    help=('Compile NS-3 with the given C++ standard'),
                    type='string', default='-std=c++11', dest='cxx_standard')
+    opt.add_option('--enable-asserts',
+                   help=('Enable the asserts regardless of the compile mode'),
+                   action="store_true", default=False,
+                   dest='enable_asserts')
+    opt.add_option('--enable-logs',
+                   help=('Enable the logs regardless of the compile mode'),
+                   action="store_true", default=False,
+                   dest='enable_logs')
 
     # options provided in subdirectories
     opt.recurse('src')
@@ -396,6 +404,11 @@
     if Options.options.build_profile == 'optimized':
         env.append_value('DEFINES', 'NS3_BUILD_PROFILE_OPTIMIZED')
 
+    if Options.options.enable_logs:
+        env.append_unique('DEFINES', 'NS3_LOG_ENABLE')
+    if Options.options.enable_asserts:
+        env.append_unique('DEFINES', 'NS3_ASSERT_ENABLE')
+
     env['PLATFORM'] = sys.platform
     env['BUILD_PROFILE'] = Options.options.build_profile
     if Options.options.build_profile == "release":
@@ -751,7 +764,8 @@
     # Each of the modules this program depends on has its own library.
     program.ns3_module_dependencies = ['ns3-'+dep for dep in dependencies]
     program.includes = "#"
-    program.use = program.ns3_module_dependencies
+    #make a copy here to prevent additions to program.use from polluting program.ns3_module_dependencies
+    program.use = program.ns3_module_dependencies.copy()
     if program.env['ENABLE_STATIC_NS3']:
         if sys.platform == 'darwin':
             program.env.STLIB_MARKER = '-Wl,-all_load'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/wutils.py ns-3.32/wutils.py
--- ns-3.31/wutils.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/wutils.py	2020-10-06 15:35:43.000000000 -0700
@@ -178,6 +178,10 @@
         argv = shlex.split(program_string)
         #print "%r ==shlex.split==> %r" % (program_string, argv)
         program_name = argv[0]
+        
+        # if the script name ends with .cc - strip it
+        if program_name.endswith('.cc'):
+            program_name = program_name.rsplit('.', 1)[0]
 
         try:
             program_obj = find_program(program_name, env)
@@ -195,6 +199,11 @@
     else:
 
         program_name = program_string
+        
+        # if the script name ends with .cc - strip it
+        if program_name.endswith('.cc'):
+            program_name = program_name.rsplit('.', 1)[0]
+
         try:
             program_obj = find_program(program_name, env)
         except ValueError as ex:
